<?php

require_once('json_base.php');
   
//-------------------------------------------------------
function make_json($array) {
	$jsonize = new Services_JSON();		
	return $jsonize->encode($array);
}

//-----------------------------------------------------------------------------
function decode_json($json_string) {
	$jsonize = new Services_JSON();
	return $jsonize->decode($json_string);
}
//-----------------------------------------------------------------------------

function get_humbug_config(){
	$hb_conf = fopen("/etc/humbug/humbug.conf", "r");
	$return  = array();
	if ($hb_conf) {
	    while (($buffer = fgets($hb_conf, 4096)) !== false) {
			$return[] = trim($buffer);
	    }
	    if (!feof($hb_conf)) {
	        print "Unexpected Error: fgets() failure reading /etc/humbug/humbug.conf\n";
			return;
	    }
	    fclose($hb_conf);
	} else {
		print "Unexpected Error. /etc/humbug/humbug.conf does not exist";
		return;
	}
	return $return;
}

//-------------------------------------------------------

function get_humbug_www_config(){
	$hb_conf = fopen("/etc/humbug/humbug_www.conf", "r");
	$return  = array();
	if ($hb_conf) {
	    while (($buffer = fgets($hb_conf, 4096)) !== false) {
			trim ($buffer);
			if (!empty($buffer)) {
				$return[] = $buffer;
			}
	    }
	    if (!feof($hb_conf)) {
	        print "Unexpected Error: fgets() failure reading /etc/humbug/humbug_www.conf\n";
			return;
	    }
	    fclose($hb_conf);
	} else {
		print "Unexpected Error. /etc/humbug/humbug_www.conf does not exist";
		return;
	}
	return $return;
}

//-------------------------------------------------------

function write_hb_config($apikey,$hkey){
		
	$hb_config = get_humbug_config();	
	$strconfig = "";
	foreach ($hb_config as $row) {
		if (substr(trim($row),0,8) == "h_apikey"){
			$strconfig .="h_apikey = ".$apikey."\n";		
		} else if (substr(trim($row),0,5) == "h_key"){
			$strconfig .="h_key = ".$hkey."\n";		
		} else {		
			$strconfig .= $row."\n";
		}
	}
	$filename 	 = '/etc/humbug/humbug.conf';
	if (!is_writable($filename)) {
	 	print "Error creating Humbug configuration. <br />Please check file permissions of <b>/etc/humbug/humbug.conf</b>.";
		return;
	}
	
    if (!$handle = fopen($filename, 'w')) {
         print "Cannot open file ($filename)";
         return;
    }
    // Write $somecontent to our opened file.
    if (fwrite($handle, $strconfig) === FALSE) {
        print "Cannot write to configuration file";
        return;
    }
    fclose($handle);
}
//-------------------------------------------------------
function write_www_config($user,$pass){
		
	$hb_config = get_humbug_www_config();	
	$strconfig = "";
	foreach ($hb_config as $row) {
		if (substr(trim($row),0,15) == 'humbug_www_user') {
			$strconfig .="humbug_www_user = ".$user."\n";
		} else if (substr(trim($row),0,15) == 'humbug_www_pass') {
			$strconfig .="humbug_www_pass = ".$pass."\n";
		} else {		
			$strconfig .= $row."\n";
		}
	}
	$filename 	 = '/etc/humbug/humbug_www.conf';
	if (!is_writable($filename)) {
	 	print "Error creating Humbug WWW configuration. <br />Please check file permissions of <b>/etc/humbug/humbug_www.conf</b>.";
		return;
	}
    if (!$handle = fopen($filename, 'w')) {
         print "Cannot open file ($filename)";
         return;
    }
    if (fwrite($handle, $strconfig) === FALSE) {
        print "Cannot write to configuration file";
        return;
    }
    fclose($handle);
}


//-------------------------------------------------------

//check to see if user exists, if not, create one
function get_user() {	
	$hb_conf = fopen("/etc/humbug/humbug_www.conf", "r");
	if (!$hb_conf) {
		return false;
	}
	$hbuser  = "";
	$hbpass  = "";
	$error 	 = false;
	if (!$hb_conf) {
		return false;
	}
    while (($buffer = fgets($hb_conf, 4096)) !== false) {
		if (!empty($buffer)){
			trim ($buffer);
			if (($buffer[0]!="#") && (($buffer[0]!="\n"))){	
				$params = explode("=",$buffer);
				if (is_array($params)){
					if (substr(trim($params[0]),0,15) == 'humbug_www_user') {
						$hbuser = trim($params[1]);
					}
					if (substr(trim($params[0]),0,15) == 'humbug_www_pass') {
						$hbpass = trim($params[1]);
					} 
				}
			}
		}
	}
	if (!feof($hb_conf)) {
	    $error    = true;	
	    print "Unexpected Error: fgets() failure\n";
		return false;
	}
	fclose($hb_conf);
	return array('hbuser'=>$hbuser,'hbpass'=>$hbpass);
}


//-------------------------------------------------------

function register_user() {
	$url 	 		= 'http://www.humbuglabs.org/index.php/index_c/api_signup/';
	$fields_string  = "";
	$darray  		= array (	'signup_name'		=>	'',
							  	'signup_email'		=>	'elastix',
							  	'signup_pass'		=>	'',
							  	'signup_company'	=>	'',
								'signup_address'	=>	'',
							    'signup_city'		=>	'',
								'signup_country'	=>	'0',
							    'signup_phone'		=>	'',
							    'signup_website'	=>	'',
								'signup_how'		=>	'palosantoelastix',
								'signup_affcode'	=>	'029f3209f2h0f9h88rvw',					  
							);
							
	foreach($darray as $key=>$value) { 
		$fields_string .= $key.'='.$value.'&'; 
	} 
	rtrim($fields_string,'&');
	//open connection 
	$ch = curl_init();
	//set the url, number of POST vars, POST data 
	curl_setopt($ch,CURLOPT_URL,$url);
	curl_setopt($ch,CURLOPT_POST,count($darray));
	curl_setopt($ch,CURLOPT_POSTFIELDS,$fields_string);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	//execute post 
	$result = curl_exec($ch);
	$result = decode_json($result);
	if ($result->result) {
		write_hb_config($result->vend_apikey,$result->vend_hkey);
		write_www_config($result->user,$result->pass);
		return true;
	} else {
		print $result->msg;
		$errormsg = $result->msg;
		return false;
	}	
	//close connection
	echo curl_error($ch);
	curl_close($ch);

	if (empty($hbuser) || empty($hbpass)) {
		$error = true;
		print "There was an error setting up Humbug Analytics. Please ensure your PBX is connected to the internet, that necessary firewall ports are open and that your humbug configurations exist in /etc/humbug/";
		return false;
	}
}

//-------------------------------------------------------
$k = time();
$result = get_user();
if (isset($result['hbuser'])) {
	if (empty($result['hbuser'])) {
		register_user();
		exec('asterisk -rx reload cdr_manager.so');
		exec('asterisk -rx reload manager');
		if (file_exists('/var/run/humbug/humbug-collector.pid')){
			exec('service generic-cloexec humbug-collector stop > /dev/null 2>&1 &');
		}
		exec('service generic-cloexec humbug-collector start > /dev/null 2>&1 &');
		header("Location: ".$_SERVER['REQUEST_URI']);
	} else {		
		print '<iframe src="http://analytics.humbuglabs.org/index.php/login/remote_login/'.sha1(trim($result['hbuser']).trim($result['hbpass']).$k).'/'.$k.'/" style="width:100%;height:100%;border:none;"></iframe>';
	}	
}

if (!file_exists('/var/run/humbug/humbug-collector.pid')){
	exec('service generic-cloexec humbug-collector start > /dev/null 2>&1 &');
}
 	
?>




